# REST API v1 changelog

> For the complete documentation index, see [llms.txt](https://developers.thoughtspot.com/docs/llms.txt)

Source: https://developers.thoughtspot.com/docs/rest-v1-changelog

# REST API v1 changelog

> **IMPORTANT:** The REST API v1 endpoints are deprecated and replaced with the REST API v2 endpoints. Your existing integrations with REST API v1 endpoints will continue to function without disruption until further notice. ThoughtSpot strongly recommends migrating your integrations to the REST API v2 endpoints.

## Version 10.4.0.cl, November 2024

TML import

The TML import API allows setting the `skip_cdw_validation_for_tables` property to specify if the Cloud Data Warehouse (CDW) validation checks for Table TMLs should be skipped.

For more information, see [TML import]({{navprefix}}/{{tml-api}}#import).

User API

You can now manage account activation status for IAMv2 users using the following API endpoints:

-   `POST /tspublic/v1/user`
    
-   `PUT /tspublic/v1/user/{userid}`
    

## Version 10.1.0.cl, August 2024

You can now export TML representation of User, User Group, and Role objects via post `/tspublic/v1/metadata/tml/export/batch`. This feature helps migrate content from one Org or one instance to another.

For more information, see [Export TML objects in bulk]({{navprefix}}/{{tml-api}}#BatchExport).

## Version 9.12.5.cl, June 2024

You can now define user attributes in your API request to the `/tspublic/v1/session/auth/token` endpoint and obtain an authentication token (JWT) and security entitlements for a given user during session creation.

For more information, see [Session token API]({{navprefix}}/{{session-api}}#session-authToken) and [Attribute-Based Access Control]({{navprefix}}/{{abac-user-parameters}}).

## Version 9.12.0.cl, May 2024

The `/tspublic/v1/metadata/tml/export` API request supports the following parameters:

-   `export_dependent`  
    Allows exporting dependent Tables while exporting a Connection.
    
-   `export_connection_as_dependent`  
    Specifies if a Connection can be exported as a dependent object when exporting a Table, Worksheet, Answer, or Liveboard. This parameter works only when `export_associated` is set to `true` in the API request.
    
-   `all_orgs_override`  
    Specifies if the export request is sent from all Orgs context.
    

For more information, see [TML API]({{navprefix}}/{{tml-api}}#export).

## Version 9.10.0.cl, March 2024

New API endpoint

`GET tspublic/v1/admin/banner`  
Gets cluster maintenance status and banner text.

For more information, see [Cluster maintenance and upgrade]({{navprefix}}/{{tse-eco-mode}}#_cluster_status_during_upgrade).

TML API

The `/tspublic/v1/metadata/tml/export` API request supports the `export_schema_version` attribute.  
You can use this parameter to specify the schema version for datasets during TML export. By default, the API request uses v1 schema for Worksheet TML export. For Models, set `export_schema_version` to `v2`.  
For more information, see [TML API]({{navprefix}}/{{tml-api}}).

## Version 9.5.0.cl, September 2023

This release introduces the REST API v1 endpoints to create and manage roles and implement Role-Based Access Control Beta:

-   `POST /tspublic/v1/role`  
    Creates a role and assign privileges
    
-   `PUT /tspublic/v1/role/{role_identifier}`  
    Updates the properties of a role object
    
-   `POST /tspublic/v1/role/search`  
    Gets details of roles and the object properties.
    
-   `DELETE /tspublic/v1/role/{role_identifier}`  
    Deletes a role object.
    

For more information, see [Role-based Access Control]({{navprefix}}/{{roles}}) and [Role API]({{navprefix}}/{{roles-api}}).

> **NOTE:** The roles APIs work only if the Role-Based Access Control (RBAC) Beta feature is enabled on your instance. The RBAC feature is turned off by default. To enable this feature, contact ThoughtSpot Support.

## Versions 9.3.0.cl and 9.4.0.cl

No new changes were introduced in the 9.3.0.cl and 9.4.0.cl releases.

## Version 9.2.0.cl, May 2023

The 9.2.0.cl release introduces the following enhancements:

-   The [`/tspublic/v1/pinboarddata`]({{navprefix}}/{{pinboarddata}}) and [`/tspublic/v1/searchdata`]({{navprefix}}/{{search-data-api}}) API endpoints support applying parameter overrides at runtime. You can pass Worksheet parameters in the request URL when making an API call to these endpoints and adjust parameter values to optimize your queries.
    
-   The `/tspublic/v1/session/login` API endpoint now allows users to log in to a specific Org with basic authentication.
    

## Version 9.0.0.cl, February 2023

The 9.0.0.cl release introduces the `/tspublic/v1/metadata/delete` endpoint, using which you can delete a metadata object.

For more information, see [Delete metadata objects]({{navprefix}}/{{metadata-api}}#del-obj).

## Version 8.10.0.cl, January 2023

The 8.10.0.cl release version introduces the following features and enhancements:

TML import API

The [`/tspublic/v1/metadata/tml/import`]({{navprefix}}/{{tml-api}}#import) endpoint now supports re-using GUIDs for new objects created during the import if the `guid` in the imported TML is not being used by any other object on the server.

APIs for Orgs

This release introduces new REST API v1 endpoints and object properties to support Org operations on a multi-tenant cluster.

Org API endpoints

For multi-tenant clusters with Orgs, ThoughtSpot provides new endpoints to allow CRUD operations for Org objects.

For more information, see [Org API]({{navprefix}}/{{org-api}}) and [Org administration and management via REST API]({{navprefix}}/{{org-manage-api}}).

Session API endpoints

If the Orgs feature is enabled and Orgs are created on your cluster, the cluster administrators can use the `/tspublic/v1/session/orgs` to [Switch between Orgs]({{navprefix}}/{{session-api}}#orgSwitch).

For deployments with the trusted authentication framework, you can use the `/tspublic/v1/session/auth/token` API endpoint lets you [create a user just-in-time and dynamically assign Orgs, groups, and privileges to that user]({{navprefix}}/{{session-api}}#session-authToken).

Mapping Orgs to users and groups

On multi-tenant clusters with Orgs, the `user` and `group` API endpoints allow assigning users and groups to an Org object. For more information, refer to the following articles:

-   [create a user]({{navprefix}}/{{user-api}}#create-user)
    
-   [update user details]({{navprefix}}/{{user-api}}#update-user)
    
-   [delete a user account]({{navprefix}}/{{user-api}}#delete-user)
    
-   [create a group]({{navprefix}}/{{group-api}}#create-group)
    

## Version 8.9.0.cl, November 2022

Session API

Starting from 8.9.0.cl, the [/tspublic/v1/session/auth/token]({{navprefix}}/{{session-api}}#session-authToken) endpoint includes the `autocreate` and `groups` properties to allow administrators to create a user just-in-time and assign groups and privileges to the user when requesting an authentication token from ThoughtSpot.

TML API

In 8.9.0.cl, ThoughtSpot will rebrand the object name `pinboard` to `liveboard` in the TML. The TML objects retrieved from ThoughtSpot via [`/tspublic/v1/metadata/tml/export`]({{navprefix}}/{{tml-api}}#export) API endpoint will show the object name as `liveboard` in the API response.

User API

The [POST /tspublic/v1/user/]({{navprefix}}/{{user-api}}#create-user) and [PUT /tspublic/v1/user/{userid}]({{navprefix}}/{{user-api}}#update-user) API endpoints allow you set the `triggeredbyadmin` flag to indicate if the user creation or update request is initiated by the ThoughtSpot admin or an external application.

## Version 8.8.0.cl, October 2022

The 8.8.0.cl release version introduces the following enhancements to connection API endpoints:

-   The `/tspublic/v1/connection/fetchLiveColumns` and `/tspublic/v1/connection/fetchConnection` API endpoints now allow filtering API response by authentication type.
    
    For more information, see [Get column data for connections with external tables]({{navprefix}}/{{connections-api}}#fetchLiveColums) and [Get details of a specific connection]({{navprefix}}/{{connections-api}}#connMetadata).
    
-   The `/tspublic/v1/connection/create` and `/tspublic/v1/connection/update` API endpoints now support adding and updating Trino and Presto data connections.
    
    For more information, see [Create a data connection]({{navprefix}}/{{connections-api}}#cre-connection) and [Connection metadata]({{navprefix}}/{{connections-api}}#connection-metadata).
    

## Version 8.7.0.cl, September 2022

The `/tspublic/v1/metadata/tml/export` API endpoint supports exporting FQNs of TML objects. To export FQNs, you must the `export_fqn` property to true in your API request.

For more information, see [Export TML]({{navprefix}}/{{tml-api}}#export).

## Version 8.6.0.cl, August 2022

The `/tspublic/v1/connection/create` and `/tspublic/v1/connection/update` API endpoints support creating and modifying Denodo data connections respectively. For more information, see [Data connection APIs]({{navprefix}}/{{connections-api}}).

## Version, 8.4.0.cl, June 2022

The `/tspublic/v1/pinboarddata` endpoint now allows retrieving transient content from a Liveboard. The `transient_pinboard_content` parameter allows you to add a script to fetch the unsaved changes if any for a given Liveboard.

For more information, see [Liveboard data API]({{navprefix}}/{{pinboarddata}}).

## Version 8.2.0.cl, April 2022

New REST API v1 endpoints for data connection queries:  

-   `[**POST** /tspublic/v1/connection/fetchConnection]({{navprefix}}/{{connections-api}}#connMetadata)`  
    
-   `[**POST** /tspublic/v1/connection/fetchLiveColumns]({{navprefix}}/{{connections-api}}#fetchLiveColums)`  
    

## Version 8.1.0.cl, March 2022

Bug fixes and improvements

## Version 8.0.0.cl, February 2022

REST clients using Postman for API calls can now send a `POST` request to the `/tspublic/v1/session/auth/token` endpoint.  
In the earlier releases, unauthenticated clients were not allowed to make an API call to `/tspublic/v1/session/auth/token` via Postman.

## Version ts8.nov.cl, January 2022

New API endpoint for token-based login

`POST /tspublic/v1/session/login/token`  

This API endpoint allows you to make a `POST` request with parameters in the request body. For more information, see [Authenticate and log in a user]({{navprefix}}/{{session-api}}#session-loginToken).

Modified endpoints

-   The `/tspublic/v1/connection/create` and `/tspublic/v1/connection/update` endpoints now allow configuring and modifying a connection without importing tables.
    
    For more information, see [Data connection APIs]({{navprefix}}/{{connections-api}}).
    
-   The `authorguid` attribute in `/tspublic/v1/metadata/list` now allows you to filter metadata objects by author GUIDs in API response.
    
    For more information, see [Get a list of metadata objects]({{navprefix}}/{{metadata-api}}#metadata-list).
    

## Version ts7.oct.cl, November 2021

New API endpoints

-   `POST /tspublic/v1/group/{groupid}/users`
    
-   `GET /tspublic/v1/group/{groupid}/users`
    
-   `PUT /tspublic/v1/user/email`
    
-   `POST /tspublic/v1/user/{userid}/groups`
    
-   `GET /tspublic/v1/user/{userid}/groups`
    
-   `PUT /tspublic/v1/user/{userid}/groups`
    
-   `DELETE /tspublic/v1/user/{userid}/groups`
    
-   `DELETE /tspublic/v1/group/{groupid}/users`
    

For more information about these APIs, see [REST API Reference]({{navprefix}}/{{rest-api-reference}}).

## Version ts7.sep.cl, October 2021

New API endpoints

-   `POST /tspublic/v1/connection/create`
    
-   `POST /tspublic/v1/connection/update`
    
-   `POST /tspublic/v1/connection/export`
    
-   `POST /tspublic/v1/connection/delete`
    
-   `POST /tspublic/v1/metadata/unassigntag`
    
-   `GET /tspublic/v1/metadata/list`
    
-   `GET /tspublic/v1/security/metadata/permissions`
    
-   `GET /tspublic/v1/security/metadata/{id}/permissions`
    
-   `GET /tspublic/v1/security/effectivepermissionbulk`
    
-   `GET /tspublic/v1/session/info`
    
-   `POST /tspublic/v1/user/activate`
    
-   `POST /tspublic/v1/user/inactivate`
    
-   `POST /tspublic/v1/user/session/invalidate`
    
-   `POST /tspublic/v1/user/resetpassword`
    
-   `PUT /tspublic/v1/group/{groupid}/users`
    
-   `POST /tspublic/v1/group/{groupid}/groups`
    
-   `PUT /tspublic/v1/group/{groupid}/groups`
    
-   `GET /tspublic/v1/group/{groupid}/groups`
    
-   `POST /tspublic/v1/group/addmemberships`
    
-   `POST /tspublic/v1/group/removememberships`
    
-   `DELETE /tspublic/v1/group/{groupid}/groups`
    

For more information, see [REST API Reference]({{navprefix}}/{{rest-api-reference}}).

Modified API endpoints

`POST /tspublic/v1/metadata/assigntag`

## Version ts7.aug.cl, September 2021

The ThoughtSpot 7 Cloud August release introduces several new API endpoints:

Admin API endpoints

-   `POST /tspublic/v1/admin/configinfo/update`
    
-   `GET /tspublic/v1/admin/configinfo/overrides`
    
-   `GET /tspublic/v1/admin/configinfo`
    
-   `GET /tspublic/v1/admin/embed/actions`
    
-   `GET /tspublic/v1/admin/embed/actions/{actionid}`
    
-   `POST /tspublic/v1/admin/embed/actions`
    
-   `DELETE /tspublic/v1/admin/embed/actions/{actionid}`
    
-   `PUT /tspublic/v1/admin/embed/actions/{actionid}`
    
-   `POST /tspublic/v1/admin/embed/action/{actionid}/associations`
    
-   `GET /tspublic/v1/admin/embed/action/{actionid}/associations`
    
-   `DELETE /tspublic/v1/admin/embed/action/{actionid}/associations`
    

For more information, see [Admin APIs]({{navprefix}}/{{admin-api}}).

Group API endpoints

-   `POST /tspublic/v1/group/`
    
-   `GET /tspublic/v1/group/`
    
-   `PUT /tspublic/v1/group/{groupid}`
    
-   `POST /tspublic/v1/group/{groupid}/user/{userid}`
    
-   `DELETE /tspublic/v1/group/{groupid}/user/{userid}`
    
-   `DELETE /tspublic/v1/group/{groupid}`
    

For more information, see [Group APIs]({{navprefix}}/{{group-api}}).

User API endpoints

-   `GET /tspublic/v1/user/`
    
-   `POST /tspublic/v1/user/`
    
-   `DELETE /tspublic/v1/user/{userid}`
    
-   `PUT /tspublic/v1/user/{userid}`
    

For more information, see [user APIs]({{navprefix}}/{{user-api}}).

Dependency API endpoints

-   \`POST /tspublic/v1/dependency/listdependents
    
-   `GET /tspublic/v1/dependency/listincomplete`
    
-   `POST /tspublic/v1/dependency/listdependents`
    
-   `GET /tspublic/v1/dependency/physicaltable`
    
-   `GET /tspublic/v1/dependency/pinboard`
    
-   `GET /tspublic/v1/dependency/logicalcolumn`
    
-   `GET /tspublic/v1/dependency/logicaltable`
    
-   `GET /tspublic/v1/dependency/logicalrelationship`
    
-   `GET /tspublic/v1/dependency/physicalcolumn`
    

For more information, see [Dependent objects APIs]({{navprefix}}/{{dependency-apis}}).

Connection API endpoints

-   `GET /tspublic/v1/connection/types`
    
-   `GET /tspublic/v1/connection/list`
    

For more information, see [Connection APIs]({{navprefix}}/{{connections-api}}).

Log API endpoint

`GET /tspublic/v1/logs/topics/{topic}` For more information, see [Audit logs API]({{navprefix}}/{{logs-api}}).

## Version ts7.jun.cl, July 2021

New API endpoints

-   `POST /tspublic/v1/security/share`
    
-   `POST /tspublic/v1/security/shareviz`
    
-   `GET /tspublic/v1/session/login/token`
    
-   `POST /tspublic/v1/metadata/assigntag`
    
-   `GET /tspublic/v1/metadata/details`
    
-   `POST /tspublic/v1/metadata/markunmarkfavoritefor`
    
-   `DELETE /tspublic/v1/metadata/markunmarkfavoritefor`
    
-   `POST /tspublic/v1/session/homepinboard`
    
-   `GET /tspublic/v1/session/homepinboard`
    
-   `DELETE /tspublic/v1/session/homepinboard`
    

For more information, see [REST API Reference]({{navprefix}}/{{rest-api-reference}}).

Other enhancements

The `POST /tspublic/v1/user/updatepreference` API now includes the optional `username` parameter. You can use either `userid` or `username` in your API request.

For more information, see [Update a user profile]({{navprefix}}/{{user-api}}#updatepreference-api).

## Version ts7.may.cl, June 2021

New endpoints

-   `**POST** /tspublic/v1/user/updatepreference`
    
-   `**GET** /tspublic/v1/metadata/listas`